<template>
  <span class="g-side">
    <span @click="toggle()">
      <slot name="toggle"></slot>
    </span>
    <div class="g-content columns is-mobile is-gapless" :class="$class">
      <div class=" column is-11 content theme">
        <span class="icon icon-button" @click="toggle()">
          <i class="fa fa-bars" aria-hidden="true"></i>
        </span>
        <slot name="content"></slot>
      </div>
      <div class="column toggle" @click="toggle()"></div>
    </div>
  </span>
</template>

<script>
export default {
  name: "gside",
  props: {
    name: {
      type: String,
      default: ""
    }
  },
  data() {
    return {
      isActive: false
    };
  },
  methods: {
    toggle: function() {
      this.isActive = !this.isActive;
    }
  },
  computed: {
    $class: function(){
      let $class = "";
      $class = (this.isActive) ? 'active '+ this.name : this.name;
      return $class
    }
  }
};
</script>

<style scoped lang="scss">
.g-side{
  .g-content{
    position: absolute;
    top: 0;
    left: 0;
    height: 100%;
    width: 100%;
    z-index: 10;
    overflow: hidden;
    transition: 300ms;
    &.active{
      transform: translateX(0px)!important;
    }
    &.left{
      transform: translateX(-100%)
    }
    &.right{
      transform: translateX(100%);
      flex-direction: row-reverse;
    }
    .content{
      -webkit-box-shadow: 20px 0px 68px 0px rgba(0,0,0,0.75);
      -moz-box-shadow: 20px 0px 68px 0px rgba(0,0,0,0.75);
      box-shadow: 20px 0px 68px 0px rgba(0,0,0,0.75);
    }
    .toggle{
      opacity: .5;
    }
  }
}
</style>
